searchNodes=[{"doc":"This is the primary public interface for Elixir Macaroons","ref":"Macaroon.html","title":"Macaroon","type":"module"},{"doc":"Add a first-party caveat to a Macaroon provided a predicate","ref":"Macaroon.html#add_first_party_caveat/2","title":"Macaroon.add_first_party_caveat/2","type":"function"},{"doc":"Add a third-party caveat to a Macaroon provided a location , predicate , and random secret caveat_key location is a hint to where the client must go to prove this caveat predicate is a string that contains caveat_key and the predicate we want to have this caveat assert you should encrypt this in such a way that only the other party can decrypt it (pub/priv keys) OR retreieve an ID from the other service first and use that as the ID. caveat_key is the freshly generated secret key that will be encrypted using the current signature of the Macaroon nonce - you SHOULD NOT override this unless you know what you're doing (it defaults to secure random bytes) it is used when encrypting the caveat_key and should never be static unless you are testing something that requires the signature to be static.","ref":"Macaroon.html#add_third_party_caveat/5","title":"Macaroon.add_third_party_caveat/5","type":"function"},{"doc":"Create an empty Macaroon with a provided location , public_id and secret","ref":"Macaroon.html#create_macaroon/3","title":"Macaroon.create_macaroon/3","type":"function"},{"doc":"Deserializes a JSON or Base64 serialized Macaroon string 2nd argument for &quot;type&quot; can be :binary or :json Returns a Macaroon.Types.Macaroon struct","ref":"Macaroon.html#deserialize/2","title":"Macaroon.deserialize/2","type":"function"},{"doc":"This prepares a Macaroon for delegation to another third-party authorization service. Returns a &quot;protected&quot; (or bound) discharge Macaroon. discharge_macaroon - The Macaroon that will be sent back to the originating service macaroon - The Macaroon that the discharge_macaroon will be bound to. (The &quot;root&quot; Macaroon)","ref":"Macaroon.html#prepare_for_request/2","title":"Macaroon.prepare_for_request/2","type":"function"},{"doc":"Serializes a Macaroon into a more transmittable format 2nd argument for &quot;type&quot; can be :binary or :json","ref":"Macaroon.html#serialize/2","title":"Macaroon.serialize/2","type":"function"},{"doc":"Module used to encode/decode a Macaroon as a binary, and encode it into Base64 (URL Safe, no padding)","ref":"Macaroon.Serializers.Binary.html","title":"Macaroon.Serializers.Binary","type":"module"},{"doc":"","ref":"Macaroon.Serializers.Binary.html#create_packet_v1/2","title":"Macaroon.Serializers.Binary.create_packet_v1/2","type":"function"},{"doc":"","ref":"Macaroon.Serializers.Binary.html#decode/2","title":"Macaroon.Serializers.Binary.decode/2","type":"function"},{"doc":"","ref":"Macaroon.Serializers.Binary.html#encode/2","title":"Macaroon.Serializers.Binary.encode/2","type":"function"},{"doc":"Module used to encode/decode a Macaroon as a JSON string","ref":"Macaroon.Serializers.JSON.html","title":"Macaroon.Serializers.JSON","type":"module"},{"doc":"","ref":"Macaroon.Serializers.JSON.html#decode/1","title":"Macaroon.Serializers.JSON.decode/1","type":"function"},{"doc":"","ref":"Macaroon.Serializers.JSON.html#encode/1","title":"Macaroon.Serializers.JSON.encode/1","type":"function"},{"doc":"Struct module for base Caveat type","ref":"Macaroon.Types.Caveat.html","title":"Macaroon.Types.Caveat","type":"module"},{"doc":"","ref":"Macaroon.Types.Caveat.html#build/0","title":"Macaroon.Types.Caveat.build/0","type":"function"},{"doc":"","ref":"Macaroon.Types.Caveat.html#build/1","title":"Macaroon.Types.Caveat.build/1","type":"function"},{"doc":"","ref":"Macaroon.Types.Caveat.html#t:t/0","title":"Macaroon.Types.Caveat.t/0","type":"type"},{"doc":"Struct module for base Macaroon type","ref":"Macaroon.Types.Macaroon.html","title":"Macaroon.Types.Macaroon","type":"module"},{"doc":"","ref":"Macaroon.Types.Macaroon.html#build/0","title":"Macaroon.Types.Macaroon.build/0","type":"function"},{"doc":"","ref":"Macaroon.Types.Macaroon.html#build/1","title":"Macaroon.Types.Macaroon.build/1","type":"function"},{"doc":"","ref":"Macaroon.Types.Macaroon.html#t:t/0","title":"Macaroon.Types.Macaroon.t/0","type":"type"},{"doc":"Struct module for Verification state and parameters","ref":"Macaroon.Types.Verification.VerifyContext.html","title":"Macaroon.Types.Verification.VerifyContext","type":"module"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyContext.html#build/0","title":"Macaroon.Types.Verification.VerifyContext.build/0","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyContext.html#build/1","title":"Macaroon.Types.Verification.VerifyContext.build/1","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyContext.html#t:t/0","title":"Macaroon.Types.Verification.VerifyContext.t/0","type":"type"},{"doc":"Struct module for Verification errors","ref":"Macaroon.Types.Verification.VerifyError.html","title":"Macaroon.Types.Verification.VerifyError","type":"module"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyError.html#build/0","title":"Macaroon.Types.Verification.VerifyError.build/0","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyError.html#build/1","title":"Macaroon.Types.Verification.VerifyError.build/1","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyError.html#t:err_type/0","title":"Macaroon.Types.Verification.VerifyError.err_type/0","type":"type"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyError.html#t:t/0","title":"Macaroon.Types.Verification.VerifyError.t/0","type":"type"},{"doc":"Struct module for Verification parameters","ref":"Macaroon.Types.Verification.VerifyParameters.html","title":"Macaroon.Types.Verification.VerifyParameters","type":"module"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyParameters.html#build/0","title":"Macaroon.Types.Verification.VerifyParameters.build/0","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyParameters.html#build/1","title":"Macaroon.Types.Verification.VerifyParameters.build/1","type":"function"},{"doc":"","ref":"Macaroon.Types.Verification.VerifyParameters.html#t:t/0","title":"Macaroon.Types.Verification.VerifyParameters.t/0","type":"type"},{"doc":"This module contains utility cryptographic functions","ref":"Macaroon.Util.Crypto.html","title":"Macaroon.Util.Crypto","type":"module"},{"doc":"","ref":"Macaroon.Util.Crypto.html#create_derived_key/1","title":"Macaroon.Util.Crypto.create_derived_key/1","type":"function"},{"doc":"","ref":"Macaroon.Util.Crypto.html#hmac_concat/3","title":"Macaroon.Util.Crypto.hmac_concat/3","type":"function"},{"doc":"","ref":"Macaroon.Util.Crypto.html#truncate_or_pad_string/2","title":"Macaroon.Util.Crypto.truncate_or_pad_string/2","type":"function"},{"doc":"Module used to verify a Macaroon","ref":"Macaroon.Verification.html","title":"Macaroon.Verification","type":"module"},{"doc":"","ref":"Macaroon.Verification.html#satisfy_exact/1","title":"Macaroon.Verification.satisfy_exact/1","type":"function"},{"doc":"","ref":"Macaroon.Verification.html#satisfy_exact/2","title":"Macaroon.Verification.satisfy_exact/2","type":"function"},{"doc":"","ref":"Macaroon.Verification.html#satisfy_general/1","title":"Macaroon.Verification.satisfy_general/1","type":"function"},{"doc":"","ref":"Macaroon.Verification.html#satisfy_general/2","title":"Macaroon.Verification.satisfy_general/2","type":"function"},{"doc":"","ref":"Macaroon.Verification.html#verify/4","title":"Macaroon.Verification.verify/4","type":"function"},{"doc":"Macaroons (For Elixir) Cookies but better. For Elixir. Requires: libsodium (can usually be easily installed using your favorite package manager)","ref":"readme.html","title":"Macaroons (For Elixir)","type":"extras"},{"doc":"What Are They? Basic Summary Caveats Verification Discharging Examples Create a Macaroon Adding Caveats Verification Serialization and Deserialize JSON Binary Misc Building on Windows If you'd like to know all the details about Macaroons, I encourage you to read the research paper ! I'll summarize it up a bit below:","ref":"readme.html#table-of-contents","title":"Macaroons (For Elixir) - Table of Contents","type":"extras"},{"doc":"Basic Summary Macaroons are bearer credentials, similar to cookies, API tokens, or JWTs. They're presented upon each of a client's request. Where Macaroons differ from most bearer credentials are the fact that they securely embed caveats (permissions, reasons, capabilities, etc.) inside the credential itself. These caveats are signed using a secret key, so the target service can trust the credential as it is presented along with the client's request. The target service can evaluate the request, and the caveats to see if the operation is allowed. Caveats Caveats are simple statements that define what capabilities, identities, or authority the Macaroon holds. Here's an example list of caveats a Macaroon may hold pertaining to an imaginary file sharing service: 1 . user_id = 1234 2 . user_upload_limit = 4 MB 3 . user_download_limit = 100 MB 4 . upload_namespace = / users / 1234 / * 5 . timestamp &lt;= 1 / 10 / 2021 - 5 : 48 : 47 PM With the examples above, the service should respect the requested operation should it meet the Macaroon's declared and signed caveats. These caveats can contain any information in any string-based format. It's up to the service author to design the predicate language used. Verification When operating a service, you can verify a Macaroon &quot;exactly&quot; or &quot;generally&quot;. Exact verification means the data of the caveat must match byte-per-byte. General verification allows the service author to provide simple callbacks which receive the caveat and can return true or false to indicate if it is met. Discharging TODO","ref":"readme.html#what-are-they","title":"Macaroons (For Elixir) - What are they?","type":"extras"},{"doc":"Creating a Macaroon m = Macaroon . create_macaroon ( &quot;http://my.cool.app&quot; , &quot;public_id&quot; , &quot;SUPER_SECRET_KEY_DO_NOT_SHARE&quot; ) Adding Caveats m = Macaroon . create_macaroon ( &quot;http://my.cool.app&quot; , &quot;public_id&quot; , &quot;SUPER_SECRET_KEY_DO_NOT_SHARE&quot; ) |&gt; Macaroon . add_first_party_caveat ( &quot;upload_limit = 4MB&quot; ) |&gt; Macaroon . add_first_party_caveat ( &quot;upload_namespace = /users/1234/*&quot; ) |&gt; Macaroon . add_third_party_caveat ( &quot;https://auth.another.app&quot; , &quot;identity_caveat&quot; , &quot;SECRET_SHARED_KEY&quot; ) Verification alias Macaroon.Verification result = Verification . satisfy_exact ( &quot;upload_limit = 4MB&quot; ) |&gt; Verification . satisfy_exact ( &quot;upload_namespace = /users/1234/*&quot; ) |&gt; Verification . satisfy_exact ( &quot;time &lt; 2022-01-01T00:00&quot; ) |&gt; Verification . verify ( macaroon , &quot;SUPER_SECRET_KEY_DO_NOT_SHARE&quot; ) # result will be {:ok, macaroon} or {:error, reason_for_failure} Serialization and Deserialize JSON { :ok , json_string } = Macaroon . create_macaroon ( &quot;http://my.cool.app&quot; , &quot;public_id&quot; , &quot;SUPER_SECRET_KEY&quot; ) |&gt; Macaroon . serialize ( :json ) macaroon = Macaroon . deserialize ( json_string , :json ) Binary { :ok , url_base64_string } = Macaroon . create_macaroon ( &quot;http://my.cool.app&quot; , &quot;public_id&quot; , &quot;SUPER_SECRET_KEY&quot; ) |&gt; Macaroon . serialize ( :binary ) macaroon = Macaroon . deserialize ( url_base64_string , :binary )","ref":"readme.html#examples","title":"Macaroons (For Elixir) - Examples","type":"extras"},{"doc":"Building on Windows (I really recommend using the Windows Linux Subsystem. It makes installing libsodium and most other things much easier. But if you must run this natively on Windows, follow these tips!) Download the latest release of libsodium, compile it using Visual Studio's compiler using x86 ReleaseDLL config. Take note of the full path where the .dll , .lib are generated. Also note where the include directory is located. Rename the generated .lib to .dll.a . Then using a Developer Command Prompt navigate to your project: set lib=%lib%;&lt;PATH_TO_FOLDER_THAT_CONTAINS_libsodium.dll.a&gt; set include=%include%;&lt;PATH_TO_FOLDER_THAT_CONTAINS_sodium.h&gt; mix deps.get and mix deps.compile 🍪 Baked with 🐾 by Digit (@doawoo) | https://puppy.surf","ref":"readme.html#misc","title":"Macaroons (For Elixir) - Misc","type":"extras"}]